diff --git a/src/runtime/bsd-os.h b/src/runtime/bsd-os.h
index 880c5f7..61aaf0e 100644
--- a/src/runtime/bsd-os.h
+++ b/src/runtime/bsd-os.h
@@ -9,7 +9,7 @@
  * files for more information.
  */
 
-#ifdef __FreeBSD__
+#if defined(__FreeBSD__) || defined(__DragonFly__)
 #include <osreldate.h>
 #endif
 
@@ -61,6 +61,14 @@ extern int sig_memory_fault;
 
 #define SIG_STOP_FOR_GC (SIGUSR2)
 
+#elif defined __DragonFly__
+
+#include <sys/ucontext.h>
+typedef ucontext_t os_context_t;
+
+#define SIG_MEMORY_FAULT (SIGSEGV)
+#define SIG_STOP_FOR_GC (SIGUSR2)
+
 #elif defined __OpenBSD__
 
 typedef struct sigcontext os_context_t;
